## lam 6.1

=== Makefile ===
##
##	Ohio Trollius
##	Copyright 1996 The Ohio State University
##
##	Function:	- grand-daddy Trollius make
##

##
## global configuration
##
include Config/config

SUBDIR	= share/h lib/otb-$(OARCH) tools-$(OARCH) \
	  otb-$(OARCH) schema man

easy: clean depend install

all: dirs
	@for i in $(SUBDIR); do \
		(cd $$i; echo $$i: ; PATH=$${PATH}:$(OBDIR) $(MAKE) all); \
	done
	@echo "Installation of LAM is complete."

depend: dirs
	@for i in $(SUBDIR); do \
		(cd $$i; echo $$i: ; $(MAKE) depend); \
	done

clean:
	@for i in $(SUBDIR); do \
		(cd $$i; echo $$i: ; $(MAKE) clean); \
	done

install: dirs
	@for i in $(SUBDIR); do \
		(cd $$i; echo $$i: ; PATH=$${PATH}:$(OBDIR) $(MAKE) install); \
	done

profile: dirs
	cd lib/otb-$(OARCH)/pmpi; $(MAKE) depend; $(MAKE) install

dirs:	$(HOME)

$(HOME):
	mkdir -p $@

=== man/Makefile ===
##
##	Ohio Trollius
##	Copyright 1996 The Ohio State University
##
##	Function:	- man pages
##

DEPTH   = ..

##
## global configuration
##
include $(DEPTH)/Config/config

all:

clean:

depend:

install: $(HOME)/man

$(HOME)/man:
	mkdir -p $(HOME)/man

	@echo copying man pages...
	@cp windex $(HOME)/man;
	@for i in man[1-9]; do \
		cp -r $$i $(HOME)/man; \
		chmod 444 $(HOME)/man/$$i/*; \
	done

=== otb/Makefile ===
##
##	Ohio Trollius
##	Copyright 1995 The Ohio State University
##
##	Function:	- OTB programs
##

DEPTH	= ..

##
## global configuration
##
include $(DEPTH)/Config/config

##
## local configuration
##
SUBDIR	= bfctl bfstate doom fctl fstate lamclean lamgrow \
	  lamshrink lamtrace loadgo mpimsg mpirun mpitask state sys tping


all:
	@for i in $(SUBDIR); do (cd $$i; echo "	"$$i: ; $(MAKE) all); \
	done

depend:
	@for i in $(SUBDIR); do (cd $$i; echo "	"$$i: ; $(MAKE) depend); \
	done

clean:
	@for i in $(SUBDIR); do (cd $$i; echo "	"$$i: ; $(MAKE) clean); \
	done

install: dirs
	@for i in $(SUBDIR); do (cd $$i; echo "	"$$i: ; $(MAKE) install); \
	done

dirs: $(OBDIR)

$(OBDIR):
	mkdir -p $(OBDIR)

=== schema/Makefile ===
##
##	Ohio Trollius
##	Copyright 1994 The Ohio State University
##
##	Function:	- process and boot schemata
##			- LAM version
##

DEPTH   = ..

##
## global configuration
##
include $(DEPTH)/Config/config

##
## local configuration
##

##
## modules and libraries
##

all:

clean:

install: dirs conf bhost

conf:
	@for i in conf.*; do \
		echo $(INSTALL) $$i $(TDIR)/$$i; \
		$(INSTALL) $$i $(TDIR)/$$i; \
	done

bhost:
	@for i in bhost.*; do \
		echo $(INSTALL) $$i $(TDIR)/$$i; \
		$(INSTALL) $$i $(TDIR)/$$i; \
	done

dirs: $(TDIR)
	
$(TDIR):
	mkdir -p $(TDIR)

##
## depend:
##
depend:

=== tools/Makefile ===
##
##	Ohio Trollius
##	Copyright 1996 The Ohio State University
##
##	Function:	- OTB node utilities
##

DEPTH	= ..

##
## global configuration
##
include $(DEPTH)/Config/config

##
## local configuration
##
SUBDIR	= hboot hcc hf77 lamboot recon tkill wipe

all:
	@for i in $(SUBDIR); do (cd $$i; echo "	"$$i: ; $(MAKE) all); \
	done

depend:
	@for i in $(SUBDIR); do (cd $$i; echo "	"$$i: ; $(MAKE) depend); \
	done

clean:
	@for i in $(SUBDIR); do (cd $$i; echo "	"$$i: ; $(MAKE) clean); \
	done

install: dirs
	@for i in $(SUBDIR); do (cd $$i; echo "	"$$i: ; $(MAKE) install); \
	done

dirs: $(OBDIR)

$(OBDIR):
	mkdir -p $(OBDIR)

=== examples/fault/Makefile ===
##
##	Ohio LAM
##
##	Function:	- Mandelbozo demo
##			- uses MPI
##

##
## hcc: LAM cc wrapper
##
CC	= hcc -O

all: master slave

slave: slave.o
	$(CC) -o slave slave.o -lmpi

master: master.o
	$(CC) -o master master.o -lmpi

clean:
	/bin/rm -f master slave master.o slave.o

=== examples/mandelbrot/Makefile ===
##
##	Ohio LAM
##
##	Function:	- Mandelbozo demo
##			- uses MPI
##

##
## hcc: LAM cc wrapper
##
CC	= hcc

all: master slave

slave: slave.o
	$(CC) -o slave slave.o -lmpi

master: master.o
	$(CC) -o master master.o -lmpi

clean:
	/bin/rm -f master slave master.o slave.o

=== examples/wave1d/Makefile ===
##
##	Ohio LAM
##
##	Function:	- 1D wave demo
##			- uses MPI library
##			- LAMHOME is the LAM installation directory.
##			- see hf77(1)
##

##
## hcc: OTB compilation
##
FC	= hf77
FFLAGS	= -I$$LAMHOME/h

wave: wave.o
	$(FC) -o wave wave.o -lmpi

wave.o: wave.F
	/bin/rm -f wave.f
	/lib/cpp -P $(FFLAGS) wave.F > wave.f
	$(FC) -c wave.f
	/bin/rm -f wave.f

clean:
	/bin/rm -f wave wave.o

=== lib/otb/Makefile ===
##
##	Ohio Trollius
##	Copyright 1995 The Ohio State University
##
##	Function:	- OTB libraries
##

DEPTH	= ../..

##
## global configuration
##
include $(DEPTH)/Config/config

##
## local configuration
##
SUBDIR	= args mpi t trillium tstdio


all:
	@for i in $(SUBDIR); do (cd $$i; echo "	"$$i: ; $(MAKE) all); \
	done

depend:
	@for i in $(SUBDIR); do (cd $$i; echo "	"$$i: ; $(MAKE) depend); \
	done

clean:
	@for i in $(SUBDIR); do (cd $$i; echo "	"$$i: ; $(MAKE) clean); \
	done

install: dirs
	@for i in $(SUBDIR); do (cd $$i; echo "	"$$i: ; $(MAKE) install); \
	done

dirs: $(OLDIR)

$(OLDIR):
	mkdir -p $(OLDIR)

=== otb/bfctl/Makefile ===
##
##	Ohio Trollius
##	Copyright 1995 The Ohio State University
##
##	Function:	- bfctl
##			- buffer control commands
##

DEPTH   = ../..

##
## global configuration
##
include $(DEPTH)/Config/config

##
## local configuration
##
VPATH	= ../../otb/bfctl
INCLUDE	= -I$(IDIR)
DEFS	=
LCFLAGS = $(INCLUDE) $(DEFS)
LDFLAGS =

##
## modules and libraries
##
LIB	= -L$(OLDIR) -largs -ltrillium -lt $(SYSLIBS)
BBIN	= bfctl
SBIN	= sweep
SRC	= bfctl.c
OBJ	= bfctl.o


all: $(BBIN)

$(BBIN): $(OBJ) $(OLDIR)/libargs.a $(OLDIR)/libtrillium.a $(OLDIR)/libt.a
	$(CC) $(LDFLAGS) -o $(BBIN) $(OBJ) $(LIB)

install: $(OBDIR)/$(BBIN) $(OBDIR)/$(SBIN)

$(OBDIR)/$(BBIN): $(BBIN)
	$(INSTALL) $(BBIN) $(OBDIR)/$(BBIN)

$(OBDIR)/$(SBIN): ../../otb/bfctl/$(SBIN)
	$(RM) $(OBDIR)/$(SBIN)
	$(INSTALL) ../../otb/bfctl/$(SBIN) $(OBDIR)/$(SBIN)

clean:
	$(RM) $(OBJ) $(BBIN)

##
## depend:
##
include	$(DEPTH)/Config/depend

##
## automatic dependencies and rules
##
include Depends

=== otb/bfstate/Makefile ===
##
##	Ohio Trollius
##	Copyright 1995 The Ohio State University
##
##	Function:	- bfstate
##			- buffer status command
##

DEPTH   = ../..

##
## global configuration
##
include $(DEPTH)/Config/config

##
## local configuration
##
VPATH	= ../../otb/bfstate
INCLUDE	= -I$(IDIR)
DEFS	=
LCFLAGS = $(INCLUDE) $(DEFS)
LDFLAGS =

##
## modules and libraries
##
LIB	= -L$(OLDIR) -largs -ltrillium -lt $(SYSLIBS)
BIN	= bfstate
SRC	= bfstate.c
OBJ	= bfstate.o


all: $(BIN)

$(BIN): $(OBJ) $(OLDIR)/libargs.a $(OLDIR)/libtrillium.a $(OLDIR)/libt.a
	$(CC) $(LDFLAGS) -o $(BIN) $(OBJ) $(LIB)

install: $(OBDIR)/$(BIN)

$(OBDIR)/$(BIN): $(BIN)
	$(INSTALL) $(BIN) $(OBDIR)/$(BIN)

clean:
	$(RM) $(OBJ) $(BIN)

##
## depend:
##
include	$(DEPTH)/Config/depend

##
## automatic dependencies and rules
##
include Depends

=== otb/doom/Makefile ===
##
##	Ohio Trollius
##	Copyright 1995 The Ohio State University
##
##	Function:	- doom
##			- signal delivery command
##

DEPTH   = ../..

##
## global configuration
##
include $(DEPTH)/Config/config

##
## local configuration
##
VPATH	= ../../otb/doom
INCLUDE	= -I$(IDIR)
DEFS	=
LCFLAGS = $(INCLUDE) $(DEFS)
LDFLAGS =

##
## modules and libraries
##
LIB	= -L$(OLDIR) -largs -ltrillium -lt $(SYSLIBS)
BIN	= doom
SRC	= doom.c
OBJ	= doom.o


all: $(BIN)

$(BIN): $(OBJ) $(OLDIR)/libargs.a $(OLDIR)/libtrillium.a $(OLDIR)/libt.a
	$(CC) $(LDFLAGS) -o $(BIN) $(OBJ) $(LIB)

install: $(OBDIR)/$(BIN)

$(OBDIR)/$(BIN): $(BIN)
	$(INSTALL) $(BIN) $(OBDIR)/$(BIN)

clean:
	$(RM) $(OBJ) $(BIN)

##
## depend:
##
include	$(DEPTH)/Config/depend

##
## automatic dependencies and rules
##
include Depends

## lam 6.3.2

=== help/Makefile ===
##
# Copyright 1998-1999, University of Notre Dame.
# Authors: Jeffrey M. Squyres, Kinis L. Meyer, with M. D. McNally 
#          and Andrew Lumsdaine
#
# This file is part of the Notre Dame LAM implementation of MPI.
#
# You should have received a copy of the License Agreement for the
# Notre Dame LAM implementation of MPI along with the software; see
# the file LICENSE.  If not, contact Office of Research, University of
# Notre Dame, Notre Dame, IN 46556.
#
# Permission to modify the code and to distribute modified code is
# granted, provided the text of this NOTICE is retained, a notice that
# the code was modified is included with the above COPYRIGHT NOTICE and
# with the COPYRIGHT NOTICE in the LICENSE file, and that the LICENSE
# file is distributed with the modified code.
#
# LICENSOR MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
# By way of example, but not limitation, Licensor MAKES NO
# REPRESENTATIONS OR WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY
# PARTICULAR PURPOSE OR THAT THE USE OF THE LICENSED SOFTWARE COMPONENTS
# OR DOCUMENTATION WILL NOT INFRINGE ANY PATENTS, COPYRIGHTS, TRADEMARKS
# OR OTHER RIGHTS.
#
# Additional copyrights may follow.
#
##
##	Function:	-  install LAM help file
##

DEPTH   = ..

MDIR	= $(LAMHOME)/share/lam

HELPSRC	= lam-helpfile
HELPDST	= $(MDIR)/lam-$(LAM_VERSION)-helpfile

##
## global configuration
##
include $(DEPTH)/config.mk

all: install

clean:

depend: $(MDIR)

install: $(MDIR) $(HELPDST)

$(MDIR):
	$(INSTALL) -m $(DIR_PERMS) -d $(MDIR)

#
# dependencies
#
$(HELPDST): lam-helpfile
	$(INSTALL) -c -m $(FILE_PERMS) lam-helpfile $(HELPDST)

=== man/Makefile ===
##
##	Ohio Trollius
##	Copyright 1997 The Ohio State University
##
##	Function:	- man pages
##

DEPTH   = ..

MDIR	= $(LAMHOME)/man

SUBDIR	= man1 man2 man3 man5 man7 share

##
## global configuration
##
include $(DEPTH)/config.mk

all: dirs

clean:

depend: dirs

install: dirs subdirs $(MDIR)/windex $(MDIR)/whatis

dirs:
	@if test ! -d $(MDIR); then mkdir -p $(MDIR); fi
	@for i in $(SUBDIR); do \
		if test ! -d $(MDIR)/$$i; then mkdir -p $(MDIR)/$$i; fi \
	done

subdirs:
	@for i in $(SUBDIR); do \
		(cd $$i; echo "	"$$i: ; $(MAKE) install) || exit 1; \
	done

#
# dependencies
#
$(MDIR)/windex: windex
	$(RM) $(MDIR)/windex
	$(CP) windex $(MDIR)
	chmod 444 $(MDIR)/windex

$(MDIR)/whatis: whatis
	$(RM) $(MDIR)/whatis
	$(CP) whatis $(MDIR)
	chmod 444 $(MDIR)/whatis

=== otb/Makefile ===
# Copyright 1998-1999, University of Notre Dame.
# Authors: Jeffrey M. Squyres, Kinis L. Meyer, with M. D. McNally 
#          and Andrew Lumsdaine
#
# This file is part of the Notre Dame LAM implementation of MPI.
#
# You should have received a copy of the License Agreement for the
# Notre Dame LAM implementation of MPI along with the software; see
# the file LICENSE.  If not, contact Office of Research, University of
# Notre Dame, Notre Dame, IN 46556.
#
# Permission to modify the code and to distribute modified code is
# granted, provided the text of this NOTICE is retained, a notice that
# the code was modified is included with the above COPYRIGHT NOTICE and
# with the COPYRIGHT NOTICE in the LICENSE file, and that the LICENSE
# file is distributed with the modified code.
#
# LICENSOR MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
# By way of example, but not limitation, Licensor MAKES NO
# REPRESENTATIONS OR WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY
# PARTICULAR PURPOSE OR THAT THE USE OF THE LICENSED SOFTWARE COMPONENTS
# OR DOCUMENTATION WILL NOT INFRINGE ANY PATENTS, COPYRIGHTS, TRADEMARKS
# OR OTHER RIGHTS.
#
# Additional copyrights may follow.
#
##
##	Ohio Trollius
##	Copyright 1997 The Ohio State University
##
##	$Id: Makefile,v 6.6 1999/06/15 03:35:03 jsquyres Exp $
##
##	Function:	- OTB programs
##

DEPTH	= ..

##
## global configuration
##
include $(DEPTH)/config.mk

##
## local configuration
##
SUBDIR	= bfctl bfstate doom fctl fstate lamclean lamexec lamgrow \
	  lamshrink lamtrace loadgo mpimsg mpirun mpitask state sys tping


all: dirs
	@for i in $(SUBDIR); \
		do (cd $$i; echo "	"$$i: ; $(MAKE) all) || exit 1; \
	done

depend: dirs
	@for i in $(SUBDIR); \
		do (cd $$i; echo "	"$$i: ; $(MAKE) depend) || exit 1; \
	done

clean:
	@for i in $(SUBDIR); \
		do (cd $$i; echo "	"$$i: ; $(MAKE) clean) || exit 1; \
	done

install: dirs
	@for i in $(SUBDIR); \
		do (cd $$i; echo "	"$$i: ; $(MAKE) install) || exit 1; \
	done

dirs: $(OBDIR)

$(OBDIR):
	mkdir -p $(OBDIR)

=== schema/Makefile ===
# Copyright 1998-1999, University of Notre Dame.
# Authors: Jeffrey M. Squyres, Kinis L. Meyer, with M. D. McNally 
#          and Andrew Lumsdaine
#
# This file is part of the Notre Dame LAM implementation of MPI.
#
# You should have received a copy of the License Agreement for the
# Notre Dame LAM implementation of MPI along with the software; see
# the file LICENSE.  If not, contact Office of Research, University of
# Notre Dame, Notre Dame, IN 46556.
#
# Permission to modify the code and to distribute modified code is
# granted, provided the text of this NOTICE is retained, a notice that
# the code was modified is included with the above COPYRIGHT NOTICE and
# with the COPYRIGHT NOTICE in the LICENSE file, and that the LICENSE
# file is distributed with the modified code.
#
# LICENSOR MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
# By way of example, but not limitation, Licensor MAKES NO
# REPRESENTATIONS OR WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY
# PARTICULAR PURPOSE OR THAT THE USE OF THE LICENSED SOFTWARE COMPONENTS
# OR DOCUMENTATION WILL NOT INFRINGE ANY PATENTS, COPYRIGHTS, TRADEMARKS
# OR OTHER RIGHTS.
#
# Additional copyrights may follow.
#
##
##	Ohio Trollius
##	Copyright 1994 The Ohio State University
##
##	Function:	- process and boot schemata
##			- LAM version
##

DEPTH   = ..

##
## global configuration
##
include $(DEPTH)/config.mk

##
## local configuration
##

##
## modules and libraries
##

all:

clean:

install: dirs files

files: $(TDIR)/bhost.def $(TDIR)/bhost.lam $(TDIR)/conf.lam $(TDIR)/conf.otb 
dirs: $(TDIR)

$(TDIR):
	$(INSTALL) -m $(DIR_PERMS) -d $(TDIR)

##
## depend:
##
depend:

$(TDIR)/bhost.def: bhost.def 
	@echo installing bhost.def
	$(INSTALL) -c -m $(FILE_PERMS) bhost.def $(TDIR)

$(TDIR)/bhost.lam: bhost.lam  
	@echo installing bhost.lam
	$(INSTALL) -c -m $(FILE_PERMS) bhost.lam $(TDIR)

$(TDIR)/conf.lam: conf.lam  
	@echo installing conf.lam
	$(INSTALL) -c -m $(FILE_PERMS) conf.lam $(TDIR)

$(TDIR)/conf.otb: conf.otb  
	@echo installing conf.otb
	$(INSTALL) -c -m $(FILE_PERMS) conf.otb $(TDIR)

=== tools/Makefile ===
##
# Copyright 1998-1999, University of Notre Dame.
# Authors: Jeffrey M. Squyres, Kinis L. Meyer, with M. D. McNally 
#          and Andrew Lumsdaine
#
# This file is part of the Notre Dame LAM implementation of MPI.
#
# You should have received a copy of the License Agreement for the
# Notre Dame LAM implementation of MPI along with the software; see
# the file LICENSE.  If not, contact Office of Research, University of
# Notre Dame, Notre Dame, IN 46556.
#
# Permission to modify the code and to distribute modified code is
# granted, provided the text of this NOTICE is retained, a notice that
# the code was modified is included with the above COPYRIGHT NOTICE and
# with the COPYRIGHT NOTICE in the LICENSE file, and that the LICENSE
# file is distributed with the modified code.
#
# LICENSOR MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
# By way of example, but not limitation, Licensor MAKES NO
# REPRESENTATIONS OR WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY
# PARTICULAR PURPOSE OR THAT THE USE OF THE LICENSED SOFTWARE COMPONENTS
# OR DOCUMENTATION WILL NOT INFRINGE ANY PATENTS, COPYRIGHTS, TRADEMARKS
# OR OTHER RIGHTS.
#
# Additional copyrights may follow.
#
##
##	Ohio Trollius
##	Copyright 1997 The Ohio State University
##
##	$Id: Makefile,v 6.6 1999/06/12 20:11:53 jsquyres Exp $
##
##	Function:	- OTB node utilities
##

DEPTH	= ..

##
## global configuration
##
include $(DEPTH)/config.mk

##
## local configuration
##
SUBDIR	= hboot hcc hf77 lamboot recon tkill wipe

all: dirs
	@for i in $(SUBDIR); \
		do (cd $$i; echo "	"$$i: ; $(MAKE) all) || exit 1; \
	done

depend: dirs
	@for i in $(SUBDIR); \
		do (cd $$i; echo "	"$$i: ; $(MAKE) depend) || exit 1; \
	done

clean:
	@for i in $(SUBDIR); \
		do (cd $$i; echo "	"$$i: ; $(MAKE) clean) || exit 1; \
	done

install: dirs
	@for i in $(SUBDIR); \
		do (cd $$i; echo "	"$$i: ; $(MAKE) install) || exit 1; \
	done

dirs: $(OBDIR)

$(OBDIR):
	@ mkdir -p $(OBDIR)

=== examples/fault/Makefile ===
##
# Copyright 1998-1999, University of Notre Dame.
# Authors: Jeffrey M. Squyres, Kinis L. Meyer, with M. D. McNally 
#          and Andrew Lumsdaine
#
# This file is part of the Notre Dame LAM implementation of MPI.
#
# You should have received a copy of the License Agreement for the
# Notre Dame LAM implementation of MPI along with the software; see
# the file LICENSE.  If not, contact Office of Research, University of
# Notre Dame, Notre Dame, IN 46556.
#
# Permission to modify the code and to distribute modified code is
# granted, provided the text of this NOTICE is retained, a notice that
# the code was modified is included with the above COPYRIGHT NOTICE and
# with the COPYRIGHT NOTICE in the LICENSE file, and that the LICENSE
# file is distributed with the modified code.
#
# LICENSOR MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
# By way of example, but not limitation, Licensor MAKES NO
# REPRESENTATIONS OR WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY
# PARTICULAR PURPOSE OR THAT THE USE OF THE LICENSED SOFTWARE COMPONENTS
# OR DOCUMENTATION WILL NOT INFRINGE ANY PATENTS, COPYRIGHTS, TRADEMARKS
# OR OTHER RIGHTS.
#
# Additional copyrights may follow.
#
##	Ohio LAM
##
##	Function:	- Mandelbozo demo
##			- uses MPI
##

include ../config-defs

all: master slave

slave: slave.o
	$(CC) -o slave slave.o $(LDFLAGS)

master: master.o
	$(CC) -o master master.o $(LDFLAGS)

clean:
	$(RM) master slave master.o slave.o

=== examples/mpi2c++/Makefile ===
##
##	$COPYRIGHT$
##
##	Function:	- Simple "ring" program in C++
##			- Stolen from the MPI 2 C++ distribution
##			- Shows how to compile MPI 2 C++ programs with LAM
##

include ../config-defs

all: ring

ring: ring.o
	$(CXX) -o ring ring.o $(LDFLAGS)

clean:
	$(RM) ring ring.o

=== examples/romio/Makefile ===
##
##	$COPYRIGHT$
##
##	Function:	- Simple ROMIO program in C
##			- Stolen from the ROMIO distribution
##			- Shows how to compile ROMIO programs with LAM
##

include ../config-defs

all: simple

simple: simple.o
	$(CC) -o simple simple.o $(LDFLAGS)

clean:
	$(RM) simple simple.o

=== examples/trivial/Makefile ===
# Generated automatically from Makefile.in by configure.
##
# Copyright 1998-1999, University of Notre Dame.
# Authors: Jeffrey M. Squyres, Kinis L. Meyer, with M. D. McNally 
#          and Andrew Lumsdaine
#
# This file is part of the Notre Dame LAM implementation of MPI.
#
# You should have received a copy of the License Agreement for the
# Notre Dame LAM implementation of MPI along with the software; see
# the file LICENSE.  If not, contact Office of Research, University of
# Notre Dame, Notre Dame, IN 46556.
#
# Permission to modify the code and to distribute modified code is
# granted, provided the text of this NOTICE is retained, a notice that
# the code was modified is included with the above COPYRIGHT NOTICE and
# with the COPYRIGHT NOTICE in the LICENSE file, and that the LICENSE
# file is distributed with the modified code.
#
# LICENSOR MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
# By way of example, but not limitation, Licensor MAKES NO
# REPRESENTATIONS OR WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY
# PARTICULAR PURPOSE OR THAT THE USE OF THE LICENSED SOFTWARE COMPONENTS
# OR DOCUMENTATION WILL NOT INFRINGE ANY PATENTS, COPYRIGHTS, TRADEMARKS
# OR OTHER RIGHTS.
#
# Additional copyrights may follow.
#
##	Ohio LAM
##
##	Function:	- Mandelbozo demo
##			- uses MPI
##

include ../config-defs

all: trivialf trivialc ezstart

trivialf: trivial.f
	$(F77) $(FFLAGS) -o trivialf trivial.f $(LDFLAGS)

trivialc: trivial.c
	$(CC) $(CFLAGS) -o trivialc trivial.c $(LDFLAGS)

ezstart: ezstart.o
	$(CC) -o ezstart ezstart.o $(LDFLAGS)

clean:
	$(RM) trivialf trivialc ezstart.o ezstart

=== examples/wave1d/Makefile ===
# Copyright 1998-1999, University of Notre Dame.
# Authors: Jeffrey M. Squyres, Kinis L. Meyer, with M. D. McNally 
#          and Andrew Lumsdaine
#
# This file is part of the Notre Dame LAM implementation of MPI.
#
# You should have received a copy of the License Agreement for the
# Notre Dame LAM implementation of MPI along with the software; see
# the file LICENSE.  If not, contact Office of Research, University of
# Notre Dame, Notre Dame, IN 46556.
#
# Permission to modify the code and to distribute modified code is
# granted, provided the text of this NOTICE is retained, a notice that
# the code was modified is included with the above COPYRIGHT NOTICE and
# with the COPYRIGHT NOTICE in the LICENSE file, and that the LICENSE
# file is distributed with the modified code.
#
# LICENSOR MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
# By way of example, but not limitation, Licensor MAKES NO
# REPRESENTATIONS OR WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY
# PARTICULAR PURPOSE OR THAT THE USE OF THE LICENSED SOFTWARE COMPONENTS
# OR DOCUMENTATION WILL NOT INFRINGE ANY PATENTS, COPYRIGHTS, TRADEMARKS
# OR OTHER RIGHTS.
#
# Additional copyrights may follow.
#
##
##	Ohio LAM
##
##	Function:	- 1D wave demo
##			- uses MPI library
##			- see hf77(1)
##

include ../config-defs

all: wave

wave: wave.f
	$(F77) -o wave wave.f $(LDFLAGS)

clean:
	$(RM) wave wave.o

=== lib/otb/Makefile ===
##
# Copyright 1998-1999, University of Notre Dame.
# Authors: Jeffrey M. Squyres, Kinis L. Meyer, with M. D. McNally 
#          and Andrew Lumsdaine
#
# This file is part of the Notre Dame LAM implementation of MPI.
#
# You should have received a copy of the License Agreement for the
# Notre Dame LAM implementation of MPI along with the software; see
# the file LICENSE.  If not, contact Office of Research, University of
# Notre Dame, Notre Dame, IN 46556.
#
# Permission to modify the code and to distribute modified code is
# granted, provided the text of this NOTICE is retained, a notice that
# the code was modified is included with the above COPYRIGHT NOTICE and
# with the COPYRIGHT NOTICE in the LICENSE file, and that the LICENSE
# file is distributed with the modified code.
#
# LICENSOR MAKES NO REPRESENTATIONS OR WARRANTIES, EXPRESS OR IMPLIED.
# By way of example, but not limitation, Licensor MAKES NO
# REPRESENTATIONS OR WARRANTIES OF MERCHANTABILITY OR FITNESS FOR ANY
# PARTICULAR PURPOSE OR THAT THE USE OF THE LICENSED SOFTWARE COMPONENTS
# OR DOCUMENTATION WILL NOT INFRINGE ANY PATENTS, COPYRIGHTS, TRADEMARKS
# OR OTHER RIGHTS.
#
# Additional copyrights may follow.
#
##	Ohio Trollius
##	Copyright 1997 The Ohio State University
##
##	$Id: Makefile,v 6.7 1999/07/26 00:34:26 kmeyer1 Exp $
##
##	Function:	- OTB libraries
##

DEPTH	= ../..

##
## global configuration
##
include $(DEPTH)/config.mk

##
## local configuration
##
SUBDIR	= args $(IMPI_DIR) mpi t trillium tstdio

all:
	@for i in $(SUBDIR); \
		do (cd $$i; echo "	"$$i: ; $(MAKE) all) || exit 1; \
	done

depend:
	@for i in $(SUBDIR); do \
		(cd $$i; echo "	"$$i: ; $(MAKE) depend) || exit 1; \
	done

clean:
	@for i in $(SUBDIR) pmpi; do \
		(cd $$i; echo "	"$$i: ; $(MAKE) clean) || exit 1; \
	done

install: dirs
	@for i in $(SUBDIR); \
		do (cd $$i; echo "	"$$i: ; $(MAKE) install) || exit 1; \
	done

dirs: $(OLDIR)

$(OLDIR):
	mkdir -p $(OLDIR)

=== man/man1/Makefile ===
##
##	Ohio Trollius
##	Copyright 1997 The Ohio State University
##
##	Function:	- man1 pages
##

DEPTH   = ../..

##
## global configuration
##
include $(DEPTH)/config.mk

MDIR	= $(LAMHOME)/man/man1

PAGES 	= $(MDIR)/bfctl.1 $(MDIR)/hboot.1 $(MDIR)/lamboot.1 $(MDIR)/loadgo.1 \
	  $(MDIR)/state.1 $(MDIR)/bfstate.1 $(MDIR)/hcc.1 $(MDIR)/lamclean.1 \
	  $(MDIR)/mpimsg.1 $(MDIR)/sweep.1 $(MDIR)/doom.1 $(MDIR)/hcp.1 \
	  $(MDIR)/lamgrow.1 $(MDIR)/mpirun.1 $(MDIR)/tkill.1 $(MDIR)/fctl.1 \
	  $(MDIR)/hf77.1 $(MDIR)/lamshrink.1 $(MDIR)/mpitask.1 \
	  $(MDIR)/tping.1 $(MDIR)/fstate.1 $(MDIR)/introu.1 \
	  $(MDIR)/lamtrace.1 $(MDIR)/recon.1 $(MDIR)/wipe.1 \
	  $(MDIR)/mpicc.1 $(MDIR)/mpiCC.1 $(MDIR)/mpif77.1 $(MDIR)/lamexec.1

all:

clean:

depend:

install: $(MDIR) $(PAGES)

$(MDIR):
	$(INSTALL) -m $(DIR_PERMS) -d $(MDIR)

#
# dependencies
#
$(MDIR)/bfctl.1: bfctl.1
	$(INSTALL) -c -m $(FILE_PERMS) bfctl.1 $(MDIR)
$(MDIR)/bfstate.1: bfstate.1
	$(INSTALL) -c -m $(FILE_PERMS) bfstate.1 $(MDIR)
$(MDIR)/doom.1: doom.1
	$(INSTALL) -c -m $(FILE_PERMS) doom.1 $(MDIR)
$(MDIR)/fctl.1: fctl.1
	$(INSTALL) -c -m $(FILE_PERMS) fctl.1 $(MDIR)
$(MDIR)/fstate.1: fstate.1
	$(INSTALL) -c -m $(FILE_PERMS) fstate.1 $(MDIR)
$(MDIR)/hboot.1: hboot.1
	$(INSTALL) -c -m $(FILE_PERMS) hboot.1 $(MDIR)
$(MDIR)/hcc.1: hcc.1
	$(INSTALL) -c -m $(FILE_PERMS) hcc.1 $(MDIR)
$(MDIR)/hcp.1: hcp.1
	$(INSTALL) -c -m $(FILE_PERMS) hcp.1 $(MDIR)
$(MDIR)/hf77.1: hf77.1
	$(INSTALL) -c -m $(FILE_PERMS) hf77.1 $(MDIR)
$(MDIR)/mpicc.1: mpicc.1
	$(INSTALL) -c -m $(FILE_PERMS) mpicc.1 $(MDIR)
$(MDIR)/mpiCC.1: mpiCC.1
	$(INSTALL) -c -m $(FILE_PERMS) mpiCC.1 $(MDIR)
$(MDIR)/mpif77.1: mpif77.1
	$(INSTALL) -c -m $(FILE_PERMS) mpif77.1 $(MDIR)
$(MDIR)/introu.1: introu.1
	$(INSTALL) -c -m $(FILE_PERMS) introu.1 $(MDIR)
$(MDIR)/lamboot.1: lamboot.1
	$(INSTALL) -c -m $(FILE_PERMS) lamboot.1 $(MDIR)
$(MDIR)/lamclean.1: lamclean.1
	$(INSTALL) -c -m $(FILE_PERMS) lamclean.1 $(MDIR)
$(MDIR)/lamgrow.1: lamgrow.1
	$(INSTALL) -c -m $(FILE_PERMS) lamgrow.1 $(MDIR)
$(MDIR)/lamshrink.1: lamshrink.1
	$(INSTALL) -c -m $(FILE_PERMS) lamshrink.1 $(MDIR)
$(MDIR)/lamtrace.1: lamtrace.1
	$(INSTALL) -c -m $(FILE_PERMS) lamtrace.1 $(MDIR)
$(MDIR)/lamexec.1: lamexec.1
	$(INSTALL) -c -m $(FILE_PERMS) lamexec.1 $(MDIR)
$(MDIR)/loadgo.1: loadgo.1
	$(INSTALL) -c -m $(FILE_PERMS) loadgo.1 $(MDIR)
$(MDIR)/mpimsg.1: mpimsg.1
	$(INSTALL) -c -m $(FILE_PERMS) mpimsg.1 $(MDIR)
$(MDIR)/mpirun.1: mpirun.1
	$(INSTALL) -c -m $(FILE_PERMS) mpirun.1 $(MDIR)
$(MDIR)/mpitask.1: mpitask.1
	$(INSTALL) -c -m $(FILE_PERMS) mpitask.1 $(MDIR)
$(MDIR)/recon.1: recon.1
	$(INSTALL) -c -m $(FILE_PERMS) recon.1 $(MDIR)
$(MDIR)/state.1: state.1
	$(INSTALL) -c -m $(FILE_PERMS) state.1 $(MDIR)
$(MDIR)/sweep.1: sweep.1
	$(INSTALL) -c -m $(FILE_PERMS) sweep.1 $(MDIR)
$(MDIR)/tkill.1: tkill.1
	$(INSTALL) -c -m $(FILE_PERMS) tkill.1 $(MDIR)
$(MDIR)/tping.1: tping.1
	$(INSTALL) -c -m $(FILE_PERMS) tping.1 $(MDIR)
$(MDIR)/wipe.1: wipe.1
	$(INSTALL) -c -m $(FILE_PERMS) wipe.1 $(MDIR)

## lam 7.1.2

=== romio/doc/Makefile ===
all:
	latex users-guide.tex
	latex users-guide.tex
	latex users-guide.tex
	dvips -o users-guide.ps users-guide.dvi
	gzip -f users-guide.ps

bib:
	latex users-guide.tex
	bibtex users-guide
	latex users-guide.tex
	latex users-guide.tex
	dvips -o users-guide.ps users-guide.dvi

clean:
	-rm -f users-guide.toc users-guide.log users-guide.dvi \
	       users-guide.aux

## lam 7.1.4

=== debian/changelog ===
lam (7.1.4-6.1) unstable; urgency=medium

  * Non maintainer upload by the Reproducible Builds team.
  * No source change upload to rebuild on buildd with .buildinfo files.

 -- Holger Levsen <holger@debian.org>  Sat, 02 Jan 2021 18:37:46 +0100

lam (7.1.4-6) unstable; urgency=medium

  * Minimal RC fix for testing migration

 -- Camm Maguire <camm@debian.org>  Fri, 29 Mar 2019 17:36:04 +0000

lam (7.1.4-5) unstable; urgency=medium

  * fix /usr/lib/lam/lib/* links in lam4-dev

 -- Camm Maguire <camm@debian.org>  Mon, 25 Mar 2019 02:24:32 +0000

lam (7.1.4-4) unstable; urgency=high

  * Accept non-maintaner upload.  Thanks Eric Dorland <eric@debian.org>
  * priority optional, thanks Andreas Beckmann <anbe@debian.org>
  * debhelper compat level 9
  * remove obsolete conflicts/replace, thanks Andreas Beckmann <anbe@debian.org>
  * remove mpi virtual package, thanks Andreas Beckmann <anbe@debian.org>
  * add breaks against old style alternatives, thanks Andreas Beckmann
  <anbe@debian.org>
  * multiarch for liblam4, thanks Andreas Beckmann <anbe@debian.org>
  * multiarch support in lam4-dev.{prerm,postinst}.in and rules, thanks Andreas
  Beckmann <anbe@debian.org>, (Closes: #924452, #922633)
  * remove old mpi alternative when appropriate in lam4-dev.preinst, thanks
  Andreas Beckmann <anbe@debian.org>
  * remove obsolete ldconfig call in liblam4.postinst, thanks Andreas Beckmann
  <anbe@debian.org>
  * thanks to Aron Xu.  (Closes: #721437)
  * standard debian build flags
  * lintian cleanups
  * latest standards

 -- Camm Maguire <camm@debian.org>  Thu, 21 Mar 2019 21:53:46 +0000

am (7.1.4-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Drop unnecessary autoconf and automake1.9 build deps. (Closes:
    #724397)

 -- Eric Dorland <eric@debian.org>  Fri, 14 Mar 2014 22:47:28 -0400

lam (7.1.4-3) unstable; urgency=low

  * Bug fix: "file conflict with lam4-dev", thanks to Peter Palfrader
    (Closes: #668217).  Conflict/replace on older lam

 -- Camm Maguire <camm@debian.org>  Mon, 09 Apr 2012 21:44:09 +0000

lam (7.1.4-2) unstable; urgency=low

  * remove libcr-dev dependency

 -- Camm Maguire <camm@debian.org>  Fri, 06 Apr 2012 20:35:41 +0000

lam (7.1.4-1) unstable; urgency=low

  * New upstream release
  * Bug fix: "typo in /etc/lam/lam-helpfile (hreq:timeout should be
    rhreq:timeout)", thanks to Sergio Gelato (Closes: #495182).  
    Applied hreq->rhreq in lam-helpfile 
  * Bug fix: "Suggest a specific ssh-client and ssh-server in Depends",
    thanks to Adam C Powell IV (Closes: #574002).  Dependencies modified
    to suggest openssh client/server.
  * build-dep on libcr-dev
  * build-dep on libltdl-dev
  * Bug fix: "bhost manpage missing", thanks to jan zacharias (Closes:
    #448495).  Move .5 and .7 lam4-dev manpages into lam-runtime.
  * Bug fix: "Make alternatives symlink for MPI_Comm_set_name manpage to
    avoid mpi-doc conflict", thanks to Adam C Powell IV (Closes: #445291).
  * use system -lltdl in place of convenience copy

 -- Camm Maguire <camm@debian.org>  Fri, 06 Apr 2012 17:38:40 +0000

lam (7.1.2-2) unstable; urgency=low

  * Bug fix: "Maintainer address seems to bounce", thanks to Alexander
    Reichle-Schmehl (Closes: #590809).

 -- Camm Maguire <camm@debian.org>  Wed, 15 Sep 2010 02:45:36 +0000

lam (7.1.2-1.6) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix CVE-2009-3726 in the internal ltdl copy (Closes: #559835)

 -- Moritz Muehlenhoff <jmm@debian.org>  Tue, 27 Jul 2010 22:29:03 -0400

lam (7.1.2-1.5) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix bashism in debian/rules (Closes: #484396)
  * Bump Standards-Version to 3.8.0.

 -- Chris Lamb <chris@chris-lamb.co.uk>  Fri, 11 Jul 2008 21:57:10 +0100

lam (7.1.2-1.4) unstable; urgency=low

  * Non-maintainer upload to fix pending l10n issues.
  * Remove debconf templates dealing with obsolete transitions.
    Closes: #388914
    This also closes pending debconf localization bug reports
    Closes: #414761, #415532, #471696, #472687

 -- Christian Perrier <bubulle@debian.org>  Mon, 17 Mar 2008 20:19:54 +0100

lam (7.1.2-1.3) unstable; urgency=low

  * Non-maintainer upload.
  * Fix the second argument to main() in the test programs used by configure.
    Fixes FTBFS with gcc-4.3.  (Closes: #468065)

 -- James Vega <jamessan@debian.org>  Sun, 09 Mar 2008 00:13:40 -0500

lam (7.1.2-1.2) unstable; urgency=low

  * Non-maintainer upload.
  * Upload to unstable

 -- Riku Voipio <riku.voipio@iki.fi>  Sat, 09 Feb 2008 23:04:48 +0200

lam (7.1.2-1.1) experimental; urgency=low

  * Non-maintainer upload.
  * transition to gfortran, closes: #456418
  * rename package for long double transition, closes: #430241
  * remove pre-depends on stone-age dpkg version
  * remove versioned depends on essential package findutils and debianutils
  * Depend on ssh-client instead of ssh, closes: #418988
  * Edit changelog to get rid of lintian warning on long changelog

 -- Riku Voipio <riku.voipio@iki.fi>  Tue, 29 Jan 2008 22:24:19 +0200

lam (7.1.2-1) unstable; urgency=low

  * New upstream release, Closes: #362168
  * Accept NMU, Closes: #359118. Closes: #355245. 
    Closes: #335721. Closes: #337843. Closes: #331881.
  * Update README.Debian, Closes: #360226
  * Add mpiexec to alternatives, Closes: #384065.

 -- Camm Maguire <camm@enhanced.com>  Tue, 26 Sep 2006 10:55:25 -0400

lam (7.1.1a-1.1) unstable; urgency=high

  * Non-maintainer upload.
  * Remove spurious confmodule invocation (Closes: #355245).
  * Add debconf-2.0 alternative (Closes: #331881).
  * Add Swedish debconf translation (Closes: #337843).
  * Add support for GNU/kFreeBSD (Closes: #335721).

 -- Luk Claes <luk@debian.org>  Sun, 26 Mar 2006 17:05:44 +0200

lam (7.1.1a-1) unstable; urgency=low

  * /u+x -> -u+x per findutils guru recommendation
  * Bug fix: "lam: source package has (unused) APSL licensed code", thanks
    to James Troup (Closes: #338249).  Files removed.



=== debian/control ===
Source: lam
Section: devel
Priority: extra
Maintainer: Camm Maguire <camm@debian.org>
Build-Depends: debhelper (>= 4.1.16),gfortran,texinfo,autotools-dev,help2man,libltdl-dev
Standards-Version: 3.9.3

Package: lam-mpidoc
Section: doc
Architecture: all
Conflicts: mpi-doc
Replaces: mpi-doc
Depends: ${misc:Depends}
Description: Documentation for the Message Passing Interface standard
 This package contains man pages describing the Message Passing 
 Interface standard.  
 .
 These pages are newly provided by the LAM package, and are also found
 in the mpi-doc package build from the mpich source package.

Package: lam4-dev
Section: devel
Architecture: any
Depends: liblam4 (= ${binary:Version}), libc6-dev,${misc:Depends}
Provides: lam-dev
Conflicts: lam-dev,lam,lam1-dev,mpi-doc (<< 1.2.7-4),lam-runtime (<= 7.1.2-2)
Replaces: lam-dev,lam,lam1-dev,lam2-dev,lam3-dev,lam-runtime (<= 7.1.2-2)
Description: Development of parallel programs using LAM
 LAM (Local Area Multicomputer) is an open source implementation of the
 Message Passing Interface (MPI) standard.
 .
 This package provides the development headers and related files.

Package: liblam4
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},${misc:Depends}
Provides: mpi
Conflicts: lam,lam1,lam4,lam4c2
Replaces: lam,lam1,lam4,lam4c2
Recommends: lam-runtime
Breaks: libopenmpi-dev (<< 3.0.1~rc1-2), openmpi-bin (<< 3.0.1~rc1-2), mpich (<< 3.3~a3-2), libmpich-dev (<< 3.3~a3-2)
Description: Shared libraries used by LAM parallel programs
 LAM (Local Area Multicomputer) is an open source implementation of the
 Message Passing Interface (MPI) standard.
 .
 This package provides the shared library.

Package: lam-runtime
Section: utils
Architecture: any
Conflicts: lam1-runtime,lam,lam4-dev (<= 7.1.2-2)
Replaces: lam1-runtime,lam,lam4-dev (<= 7.1.2-2)
Depends: ${shlibs:Depends},openssh-client | ssh-client | rsh-client,openssh-server | ssh-server | rsh-server,${misc:Depends}
Description: LAM runtime environment for executing parallel programs
 LAM (Local Area Multicomputer) is an open source implementation of the
 Message Passing Interface (MPI) standard.
 .
 Some enhancements in LAM 6.3 are: 
  o Added the MPI-2 C++ bindings package (chapter 10 from the MPI-2 
      standard) from the Laboratory for Scientific Computing at the 
      University of Notre Dame. 
  o Added ROMIO MPI I/O package (chapter 9 from the MPI-2 standard) 
      from the Argonne National Laboratory. 
  o Pseudo-tty support for remote IO (e.g., line buffered output). 
  o Ability to pass environment variables through mpirun. 
  o Ability to mpirun shell scripts/debuggers/etc. (that eventually 
      run LAM/MPI programs). 
  o Ability to execute non-MPI programs across the multicomputer. 
  o Added configurable ability to zero-fill internal LAM buffers 
      before they are used (for development tools such as Purify). 
  o Greatly expanded error messages; provided for customizable  
      local help files. 
  o Expanded and updated documentation. 
  o Various bug fixes and minor enhancements.

=== debian/rules ===
#!/usr/bin/make -f
# Made with the aid of dh_make, by Craig Small
# Sample debian/rules that uses debhelper. GNU copyright 1997 by Joey Hess.
# This version is for a hypothetical package that builds an
# architecture-dependant package, as well as an architecture-independant
# package.

SO=4
MIN=0
VER=$(SO).$(MIN)

CC=cc
package=lam

version=$(shell expr `pwd` : '.*-\([0-9.]*\)')
version_major=$(shell expr `pwd` : '.*-\([0-9]*\).[0-9.]*')

# Uncomment this to turn on verbose mode. 
#export DH_VERBOSE=1
#export DH_COMPAT=2

TDIR:=$(shell pwd)

MEXT=tmp
MDIR:=debian/$(MEXT)
LAMV:=usr/lib/lam
LAMD:=$(MDIR)/$(LAMV)
OLDIR=$(LAMD)/lib
OBDIR=$(LAMD)/bin
SHLDIR=$(subst $(MEXT),shared,$(OLDIR))
SHBDIR=$(subst $(MEXT),shared,$(OBDIR))
SHIDIR:=$(SHBDIR)/../include
STLDIR=$(subst $(MEXT),static,$(OLDIR))
STBDIR=$(subst $(MEXT),static,$(OBDIR))
LDIR:=$(MDIR)/usr/lib
BDIR:=$(MDIR)/usr/bin
WDIR:=tools/wrappers
MPROX:=$(MDIR)/usr/share/man/man3/MPI_Wtime.3
MSRC:=debian/static/$(LAMV)/man/man3/MPI_Wtime.3
mans:=lamhalt lamnodes
MMDIR:=debian/$(MEXT)/usr/share/man/man1
MMAN:=$(addprefix $(MMDIR)/,$(addsuffix .1,$(mans)))
SUB:=$(shell find * -name config.sub |grep -v debian)
GUESS:=$(shell find * -name config.guess |grep -v debian)
#CONFIGURE:=$(shell find * -name configure)
DSUB:=$(addprefix debian/conf/,$(SUB))
DGUESS:=$(addprefix debian/conf/,$(GUESS))

export DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
export DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
export DEB_HOST_GNU_SYSTEM ?= $(shell dpkg-architecture -qDEB_HOST_GNU_SYSTEM)
export DEB_HOST_MULTIARCH  ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ARCHT:=$(shell echo $(DEB_HOST_GNU_TYPE) | cut -f1 -d-)
OPTFLAGS:=
ifeq ($(ARCHT),m68k)
OPTFLAGS:=-O2
endif

dlibs:= lam lamf77mpi lammpi++ mpi lammpio 
stlibs:=$(addprefix $(STLDIR)/lib,$(addsuffix .a,$(dlibs)))
shlibs:=$(addprefix $(SHLDIR)/lib,$(addsuffix .a,$(dlibs)))

tlibs:=lam  lamio lam++
libs: $(addprefix $(LDIR)/lib,$(addsuffix .so,$(tlibs)) $(addsuffix .a,$(tlibs))) 

dbins:=lamclean lamexec lamgrow lamshrink lamtrace mpimsg mpirun mpiexec mpitask lamd tping \
	hboot lamboot laminfo lamhalt lamnodes recon tkill lamwipe   mpicc mpif77 mpic++
nbins:=lamclean lamexec lamgrow lamshrink lamtrace mpimsg mpirun.lam mpiexec.lam mpitask lamd tping \
	hboot lamboot laminfo lamhalt lamnodes recon tkill lamwipe  mpicc.lam\
	 mpif77.lam mpic++.lam

tbins:=$(addprefix $(BDIR)/,$(nbins))
shbins:=$(addprefix $(SHBDIR)/,$(dbins)))
bins: $(tbins)

$(DSUB):
	mkdir -p $(@D)
	cp $(subst debian/conf/,,$@) $@

$(SUB): $(DSUB)
	chmod +w $@
	cp /usr/share/misc/config.sub $@

$(DGUESS):
	mkdir -p $(@D)
	cp $(subst debian/conf/,,$@) $@

$(GUESS): $(DGUESS)
	chmod +w $@
	cp /usr/share/misc/config.guess $@

#$(CONFIGURE): FORCE
#	! [ -r $(@D)/configure.in ] || touch $(@D)/configure.in
#	sleep 2
#	! [ -r $(@D)/aclocal.m4 ] || touch $(@D)/aclocal.m4
#	sleep 2
#	touch $@

FORCE:

$(stlibs): $(SUB) $(GUESS) #$(CONFIGURE)

	[ ! -f Makefile ] || $(MAKE) distclean
#	-$(MAKE) clean

	CC="gcc" CXX="g++" F77="gfortran" FC="gfortran" \
	CFLAGS="$(OPTFLAGS)" CXXFLAGS="$(OPTFLAGS)" FFLAGS="$(OPTFLAGS)" \
	./configure --prefix=/$(LAMV) \
		     --build=$(DEB_BUILD_GNU_TYPE) \
		     --host=$(DEB_HOST_GNU_TYPE) \
		     --with-rsh=/usr/bin/rsh \
		     --with-rpi=sysv 

	awk '/LAM_HAVE_OPENPTY/ {gsub("1","0")} /LAM_HAVE_SYSV_PTYS/ {gsub("1","0")}  {print}' \
		share/include/lam_config.h >tmp && mv tmp share/include/lam_config.h

	$(MAKE) 

	$(MAKE) install DESTDIR=$(subst $(LAMV)/lib,,$(TDIR)/$(@D))


$(MSRC) $(SHIDIR)/mpi.h $(shbins) $(shlibs): $(SUB) $(GUESS) #$(CONFIGURE)

	[ ! -f Makefile ] || $(MAKE) distclean
#	-$(MAKE) clean

	CC="gcc" CXX="g++" F77="gfortran" FC="gfortran" \
	CFLAGS="$(OPTFLAGS) -fPIC" CXXFLAGS="$(OPTFLAGS) -fPIC" FFLAGS="$(OPTFLAGS) -fPIC" \
	./configure --prefix=/$(LAMV) \
		     --build=$(DEB_BUILD_GNU_TYPE) \
		     --host=$(DEB_HOST_GNU_TYPE) \
		     --with-rsh=/usr/bin/rsh \
		     --with-trillium \
		     --with-rpi=sysv 

	awk '/LAM_HAVE_OPENPTY/ {gsub("1","0")} /LAM_HAVE_SYSV_PTYS/ {gsub("1","0")}  {print}' \
		share/include/lam_config.h >tmp && mv tmp share/include/lam_config.h

	$(MAKE) 

	$(MAKE) install DESTDIR=$(subst $(LAMV)/bin,,$(subst $(LAMV)/lib,,$(TDIR)/$(@D)))


ERM:=pmpil_trace_f.o pdupfn_f.o mpietc.o



$(LDIR)/liblam.so.$(VER): $(addprefix $(SHLDIR)/,liblamf77mpi.a libmpi.a liblam.a)
	mkdir tmp 
	chmod +x debian/mar
	cd tmp && mkdir $(^F) && echo $(addprefix ../../,$^) | xargs -t -n 1 ../debian/mar
	rm -f $(addprefix tmp/libmpi.a/,$(ERM)) $(addprefix tmp/liblam.a/,ltdl.o)
	mkdir -p $(@D)
	$(CC) -shared -Wl,-soname=$(@F:.$(VER)=.$(SO)) -o $@ tmp/*/*.o -lpthread -lltdl # -ldl -lutil -lcr
	rm -rf tmp

$(LDIR)/libplam.so.$(VER): $(addprefix $(SHLDIR)/,liblamf77mpi.a liblam.a  )
	mkdir tmp
	cd tmp && echo $(addprefix ../,$^) | xargs -t -n 1 ar x && rm -f $(ERM)
	mkdir -p $(@D)
	$(CC) -shared -Wl,-soname=$(@F:.$(VER)=.$(SO)) -o $@ tmp/*.o # -lutil
	rm -rf tmp

$(LDIR)/liblamio.so.$(VER): $(SHLDIR)/liblammpio.a $(LDIR)/liblam.so
	mkdir tmp
	cd tmp && echo $(addprefix ../,$<) | xargs -t -n 1 ar x && rm -f $(ERM)
	mkdir -p $(@D)
ifeq ($(DEB_HOST_GNU_SYSTEM),kfreebsd-gnu)
# aio is enable by default on GNU/kFreeBSD, because of UFS support
	$(CC) -shared -Wl,-soname=$(@F:.$(VER)=.$(SO)) -o $@ tmp/*.o -L$(LDIR) -llam -lrt # -lutil
else
	$(CC) -shared -Wl,-soname=$(@F:.$(VER)=.$(SO)) -o $@ tmp/*.o -L$(LDIR) -llam # -lutil
endif
	rm -rf tmp

$(LDIR)/liblam++.so.$(VER): $(SHLDIR)/liblammpi++.a $(LDIR)/liblam.so
	mkdir tmp
	cd tmp && echo $(addprefix ../,$<) | xargs -t -n 1 ar x && rm -f $(ERM)
	mkdir -p $(@D)
	g++ -shared -Wl,-soname=$(@F:.$(VER)=.$(SO)) -o $@ tmp/*.o -L$(LDIR) -llam # -lutil
	rm -rf tmp

lib%.so.$(SO): lib%.so.$(VER)
	ln -snf $(<F) $@

lib%.so: lib%.so.$(SO)
	ln -snf $(<F) $@




$(LDIR)/liblam.a: $(addprefix $(STLDIR)/,liblamf77mpi.a libmpi.a liblam.a )
	mkdir tmp
	cd tmp && echo $(addprefix ../,$^) | xargs -t -n 1 ar x 
	rm -f $@
	mkdir -p $(@D)
	ar r $@ tmp/*.o
	rm -rf tmp

$(LDIR)/libplam.a: $(addprefix $(STLDIR)/,liblamf77mpi.a liblam.a  )
	mkdir tmp
	cd tmp && echo $(addprefix ../,$^) | xargs -t -n 1 ar x 
	rm -f $@
	mkdir -p $(@D)
	ar r $@ tmp/*.o
	rm -rf tmp

$(LDIR)/liblamio.a: $(STLDIR)/liblammpio.a
	mkdir tmp
	cd tmp && echo $(addprefix ../,$^) | xargs -t -n 1 ar x 
	rm -f $@
	mkdir -p $(@D)
	ar r $@ tmp/*.o
	rm -rf tmp

$(LDIR)/liblam++.a: $(STLDIR)/liblammpi++.a
	mkdir tmp
	cd tmp && echo $(addprefix ../,$^) | xargs -t -n 1 ar x 
	rm -f $@
	mkdir -p $(@D)
	ar r $@ tmp/*.o
	rm -rf tmp

define relink
	mkdir -p $(@D)
	cd $$(dirname $$(find -name $(<F) -perm -u+x -type f |grep -v debian)) && \
		mv -f $(<F) $(<F).old && \
		( $(MAKE) -n $(<F) | awk '/mkdir/ {next} /libtool/ { \
				gsub("-lutil",""); \
				gsub("[^ ]*libltdlc\\.la",""); \
				gsub("[^ ]*liblam\\.la","-L'$(TDIR)/$(LDIR)' -llam"); \
				gsub("[^ ]*libmpi\\.la","-L'$(TDIR)/$(LDIR)' -llam"); \
				gsub(" $(subst +,\\+,$(<F)) "," '$(TDIR)/$(@)' "); \
				print}' | bash -x -e || (mv $(<F).old $(<F) && false)) && \
		mv $(<F).old $(<F)
endef

$(BDIR)/%: $(SHBDIR)/% $(LDIR)/liblam.so
	$(relink)
$(addprefix $(BDIR)/, lamsweep): $(BDIR)/lam%: $(SHBDIR)/% $(LDIR)/liblam.so
	$(relink)
$(BDIR)/%.lam: $(SHBDIR)/% $(LDIR)/liblam.so
	$(relink)
$(BDIR)/mpiexec.lam: $(SHBDIR)/mpiexec
	cp $< $@

#$(addprefix $(BDIR)/,lamwipe lamsweep): $(BDIR)/lam% : $(SHBDIR)/% $(LDIR)/liblam.so
#	mkdir -p $(@D)
#	cd $$(find -name $(<F) -type d |grep -v share) && \
#		rm -f $(<F) && \
#		$(MAKE) -n $(<F) | awk '/libtool/ { \
#				gsub("[^ ]*liblam\.la","-L'$(TDIR)/$(LDIR)' -llam"); \
#				gsub(" '$(<F)' "," '$(TDIR)/$(@)' "); \
#				print}' | bash -x -e

#$(BDIR)/mpirun.lam: $(SHBDIR)/mpirun $(LDIR)/liblam.so
#	mkdir -p $(@D)
#	cd $$(find -name $(<F) -type d |grep -v share) && \
#		rm -f $(<F) && \
#		$(MAKE) -n $(<F) | awk '/libtool/ { \
#				gsub("[^ ]*liblam\.la","-L'$(TDIR)/$(LDIR)' -llam"); \
#				gsub(" '$(<F)' "," '$(TDIR)/$(@)' "); \

=== debian/watch ===
# Example watch control file for uscan
# Rename this file to "watch" and then you can run the "uscan" command
# to check for upstream updates and more.
# Site		Directory		Pattern			Version	Script
version=2
http://www.lam-mpi.org/download/files/	.*lam-([0-9\\.]*).tar.gz	debian	uupdate
